       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPLA191.
      *
      * OGGETTO: CREAZIONE ARCHIVIO LETTERE D'INTENTO
      *         
      * versione P2004 declassato per P1703 (senza P1705)
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'griditsl'.
           COPY 'griaazsl'.
           SELECT LETINT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-LET.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'grilet'.
           COPY 'griclf'.
           COPY 'gridit'.
           COPY 'griaaz'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-73'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'griclfrk'.
           COPY 'grid02rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prfisc'.
           COPY 'parpcfgr'.
           COPY 'parpcfgc'.
           COPY 'parmb'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-LET PIC X(80) VALUE 'letint'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-DIT PIC X(15) VALUE 'leitab'.
       01  ID-AAZ PIC X(15) VALUE 'appazi'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-LET  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-DIT  PIC XX.
           05 SF-AAZ  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 J2      PIC 9(3)  VALUE ZERO.
           05 COMDT   PIC 9(8)  VALUE ZERO.
           05 COMDA   PIC 9(4)  VALUE ZERO.
           05 FLPAG   PIC 9      VALUE ZERO.
           05 TESTA   PIC 9      VALUE ZERO.
           05 PATH     PIC X(80) VALUE SPACE.
           05 UFF      PIC X(20) VALUE SPACE.
           05 NRECB  PIC 9(9)  VALUE ZERO.
           05 COMIMPO PIC ZZZZZZZZZZZZ9,99  VALUE ZERO.
           05 COMIMPC PIC ZZZZZZZZZZZZ9,99  VALUE ZERO.
      **** rel 7.2
           05 COM-DTIMP PIC 9(5)  VALUE ZERO.
      *********

           05 CODICE3.
              10 MAS3   PIC 99.
              10 COD3   PIC 9(5).
           05 CODICE.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 CODICE2.
              10 MAS2  PIC 99.
              10 COD2  PIC 9(5).

           05 SAV-PIVA  PIC 9(11).
           05 SAV-PRT   PIC 9(4).


           05 MODELLO.
              10 MOD PIC X(2) VALUE 'IV'.
              10 LET PIC X    VALUE 'I'.
              10 ANM PIC 9(2) VALUE 15.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC  X(36).      
      *                                                     
           05 IF-DICO      PIC  9.      
           05 IF-PROT1     PIC  9(17).      
           05 IF-PROT2     PIC  9(6).      
           05 IF-DOGA      PIC  9.      
           05 IF-COD-1     PIC  9(5).       
           05 IF-COD-2     PIC  9(5).       
           05 IF-COD       PIC  9(5).       
           05 IF-NPRT      PIC  9(4).       
           05 IF-ANNO      PIC  9(4).       
      **** rel 7.2
           05 IF-DTIMP     PIC  9(6).       
      *********
      *                                                      
           05 IF-DESCR-1   PIC  X(100).      
           05 IF-TPDIC     PIC  9(1).       
           05 IF-IMPOR     PIC  9(11)V99.
           05 IF-PERG1     PIC  9(2).       
           05 IF-PERM1     PIC  9(2).       
           05 IF-PERG2     PIC  9(2).       
           05 IF-PERM2     PIC  9(2).       
      *
           05 IF-FILE      PIC  X(80).      
      **** rel 7.2
           05 IF-RGSOC     PIC  X(36).       
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dcllet'.
           COPY 'dclclf'.
           COPY 'dcldit'.
           COPY 'dclaaz'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vpla191: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE LETINT.
           CLOSE ANACLF.
           CLOSE LEITAB.
           CLOSE APPAZI.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'griditer'.
           COPY 'griaazer'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           OPEN I-O TABELL.
           OPEN INPUT ANACLF.
           OPEN INPUT LEITAB.
           OPEN INPUT APPAZI.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY 
             PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MAS MAS2 MAS3.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID KEY PERFORM INVK-AZI
                                               GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE ZERO    TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-UFF TO UFF.
           MOVE '1' TO T25-PRG
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
      *
           MOVE KAZ-COD TO KAAZ-COD.
           READ APPAZI INVALID
                       MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA
                                     AAZ-SES
                       MOVE ZERO TO AAZ-DNA.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE ZERO TO COD COD2.

           MOVE ZERO  TO IF-DICO.
           MOVE ZERO  TO IF-PROT1.
           MOVE ZERO  TO IF-PROT2.
           MOVE ZERO  TO IF-DOGA.
           MOVE ZERO  TO IF-COD.
           MOVE ZERO  TO IF-COD-1.
           MOVE ZERO  TO IF-COD-2.
           MOVE ZERO  TO IF-NPRT.
           MOVE ZERO  TO IF-ANNO.
           MOVE SPACE TO IF-DESCR-1.
           MOVE ZERO  TO IF-IMPOR.
           MOVE ZERO  TO IF-PERG1.
           MOVE ZERO  TO IF-PERM1.
           MOVE ZERO  TO IF-PERG2.
           MOVE ZERO  TO IF-PERM2.
      **** rel 7.2
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO IF-DTIMP.
           MOVE AA9 TO GG9.
           MOVE IF-DTIMP TO AA9.
           MOVE GGMMAA TO IF-DTIMP.
      *********

           MOVE AZRGSOC TO IF-AZI-D.
           MOVE 2 TO IF-TPDIC.

           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.

           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE ZERO    TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-UFF TO UFF.
           MOVE '1' TO T25-PRG
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-PRT TO IF-NPRT SAV-PRT.
           ADD 1 TO SAV-PRT.
      *
           MOVE AA9 TO AA4.
           CALL 'ranno4' USING AA4.
           MOVE AA4 TO IF-ANNO.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
      *
           MOVE AZI-PIVA TO SAV-PIVA.
           MOVE SPACE TO ID-LET.
           STRING D02-PATHECF  DELIMITED SPACE
                  SAV-PIVA     DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  IF-ANNO(3:2) DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  SAV-PRT      DELIMITED SPACE
                  '_ivi15'     DELIMITED SIZE INTO ID-LET.
           MOVE ID-LET TO IF-FILE.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DICO.
           MOVE 'IF-DICO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT1.
           IF IF-DICO = ZERO
              MOVE ZERO TO IF-PROT1 IF-PROT2.
       E-DICO.
      *
       V-PROT1.
           MOVE 'IF-PROT1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT1.
           IF IF-DICO NOT = ZERO
              IF IF-PROT1 = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR. 
       E-PROT1.
      *
       V-PROT2.
           MOVE 'IF-PROT2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT2.
           IF IF-DICO NOT = ZERO
              IF IF-PROT2 = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR. 
       E-PROT2.
      *
       V-DOGA.
           MOVE 'IF-DOGA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DOGA.
           IF IF-DOGA = 1
              MOVE ZERO TO IF-COD-1 IF-COD-2
           ELSE
              MOVE ZERO TO IF-COD.
       E-DOGA.
      *
       V-COD.
           MOVE 'IF-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD.
           IF IF-DOGA = ZERO GO TO E-COD.
           IF IF-COD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-COD TO COD3.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE CODICE3 TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF CLF-13IVA NOT = 3
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD.

       V-COD-1.
           MOVE 'IF-COD-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-1.
           IF IF-DOGA = 1 GO TO E-COD-1.
           IF IF-COD-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-COD-1 TO COD.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE CODICE  TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
              MOVE ZERO TO CLF-13IVA
              MOVE SPACE TO CLF-RGSOC2 CLF-INDIR2
              MOVE SPACE TO CLF-RGSOC.
      **** rel 7.2
           IF FUN = 'V'
              MOVE IF-COD-1 TO IF-COD-2.
      ************
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
       E-COD-1.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-DOGA = 1 GO TO E-COD-2.
           IF IF-COD-1 > IF-COD-2
              PERFORM ERR-DINC
              GO TO V-ERROR.
           MOVE IF-COD-2 TO COD2.
           MOVE KAZ-COD  TO KCF-AZI.
           MOVE CODICE2  TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY 
              MOVE ZERO TO CLF-13IVA
              MOVE SPACE TO CLF-RGSOC2 CLF-INDIR2
              MOVE SPACE TO CLF-RGSOC.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           IF CLF-13IVA = 3 
              PERFORM ERR-DINC
              GO TO V-ERROR.
           IF IF-DICO = 1
              IF IF-COD-2 NOT = IF-COD-1
                 PERFORM ERR-DINC
                 GO TO V-ERROR.
      *
           MOVE SPACE TO IF-RGSOC.
           IF IF-COD-2 NOT = IF-COD-1 GO TO E-COD-2.
      *
           MOVE CLF-RGSOC TO IF-RGSOC.
      *
           IF CLF-ESEN = ZERO GO TO SEGNALAZIONE.
           MOVE 3 TO KTB-TIP.
           MOVE CLF-ESEN TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO SEGNALAZIONE.
           IF T03-TPIVA NOT = 6 GO TO SEGNALAZIONE.
           GO TO E-COD-2.
       SEGNALAZIONE.
           MOVE 'Fornitore con tipo esenzione iva non' TO F-MES1.
           MOVE 'coerente'                             TO F-MES2.
           MOVE 2 TO F-NMES.
           MOVE 'W' TO MB-TIPO.
           MOVE '1' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
       E-COD-2.
      *
       V-ANNO.
           MOVE 'IF-ANNO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ANNO.
           CALL 'ranno4' USING IF-ANNO.
           IF IF-ANNO < 1990
              PERFORM ERR-DINC
              GO TO V-ERROR.
           MOVE AZI-PIVA TO SAV-PIVA.
           MOVE SPACE TO ID-LET.
           COMPUTE SAV-PRT = IF-NPRT + 1.
           STRING D02-PATHECF DELIMITED SPACE
                  SAV-PIVA    DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  IF-ANNO(3:2) DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  SAV-PRT     DELIMITED SPACE
                  '_ivi15'    DELIMITED SIZE INTO ID-LET.
           MOVE ID-LET TO IF-FILE.
       E-ANNO.
      *
      **** rel 7.2
       V-DTIMP.
           MOVE 'IF-DTIMP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIMP.
           IF IF-DTIMP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      *
           MOVE IF-DTIMP TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO COM-DTIMP.
       E-DTIMP.
      *
      *********
       V-TPDIC.
           MOVE 'IF-TPDIC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPDIC.
           IF IF-TPDIC = 1 
              MOVE ZERO TO IF-PERG1 IF-PERG2 IF-PERM1 IF-PERM2.
           IF IF-TPDIC = 2
              MOVE ZERO TO IF-PERG1 IF-PERG2 IF-PERM1 IF-PERM2.
           IF IF-TPDIC = 3 
              MOVE ZERO TO IF-IMPOR.
       E-TPDIC.
      *
       V-IMPOR.
           MOVE 'IF-IMPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPOR.
           IF IF-TPDIC = 3 GO TO E-IMPOR.
           IF IF-IMPOR = ZERO
              PERFORM ERR-ZERO 
              GO TO V-ERROR.
           IF IF-TPDIC = 1
              IF IF-DOGA = ZERO
                 IF IF-COD-1 NOT = IF-COD-2
                    MOVE 'Selezionare un solo fornitore' TO MESS
                    GO TO V-ERROR.
       E-IMPOR.
      *
       V-PERG1.
           MOVE 'IF-PERG1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERG1.
           IF IF-TPDIC NOT = 3 GO TO E-PERG1.
           IF IF-PERG1 = ZERO OR > 31 
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-PERG1.
      *
       V-PERM1.
           MOVE 'IF-PERM1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERM1.
           IF IF-TPDIC NOT = 3 GO TO E-PERM1.
           IF IF-PERM1 = ZERO OR > 12 
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF ( IF-PERM1 = 2 AND  IF-PERG1 > 29 ) OR
              (( IF-PERM1 = 4 OR 6 OR 9 OR 11) AND IF-PERG1 > 30)
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-PERM1.
      *
       V-PERG2.
           MOVE 'IF-PERG2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERG2.
           IF IF-TPDIC NOT = 3 GO TO E-PERG2.
           IF IF-PERG2 = ZERO OR > 31 
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-PERG2.
      *
       V-PERM2.
           MOVE 'IF-PERM2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERM2.
           IF IF-TPDIC NOT = 3 GO TO E-PERM2.
           IF IF-PERM2 = ZERO OR > 12 
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF ( IF-PERM2 = 2 AND  IF-PERG2 > 29 ) OR
              (( IF-PERM2 = 4 OR 6 OR 9 OR 11) AND IF-PERG2 > 30)
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-PERM2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *
           MOVE IF-NPRT TO SAV-PRT. 
           ADD 1 TO SAV-PRT.
           MOVE ZERO TO NRECB.
           IF IF-DOGA = 1
              MOVE CODICE3 TO CODICE CODICE2.
           MOVE ZERO TO TESTA.
      **** nt72 
      *    MOVE KAZ-COD  TO KAZ-COD.
           MOVE KAZ-COD  TO KCF-AZI.
      **********
           MOVE CODICE   TO KCF-COD.
           START ANACLF KEY NOT < KEYCF INVALID GO TO FNSTA.
       RDBL.
           READ ANACLF NEXT INTO REKCLF AT END GO TO FNSTA.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO RDBL.
           IF KCF-AZI > KAZ-COD GO TO FNSTA.
           IF KCF-COD  > CODICE2 GO TO FNSTA.
      *
           IF IF-DOGA = 1 GO TO STAMP.
           IF CLF-13IVA = 3 GO TO RDBL.
           IF CODICE = CODICE2 GO TO STAMP.
           IF CLF-ESEN = ZERO GO TO RDBL.
           MOVE 3 TO KTB-TIP.
           MOVE CLF-ESEN TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO RDBL.
           IF T03-TPIVA NOT = 6 GO TO RDBL.
      *
       STAMP.
           IF TESTA = ZERO
              OPEN OUTPUT LETINT
              MOVE 1 TO TESTA
              PERFORM CREA-REC-A THRU EX-REC-A.
           PERFORM CREA-REC-B THRU EX-REC-B.
           GO TO RDBL.
       FNSTA.
           IF TESTA NOT = ZERO
              PERFORM CREA-REC-Z THRU EX-REC-Z.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-REC-A.
           MOVE SPACE   TO LETA.
       
           MOVE 'A'     TO LETA-TRA.
           MOVE MODELLO TO LETA-CDF.
      *
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'I'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
      *
           IF D02-CFINT NOT = SPACE 
              MOVE 10 TO LETA-TFO
              MOVE D02-CFINT  TO LETA-CFFO
           ELSE
              MOVE 01 TO LETA-TFO
              MOVE AZI-CFISC  TO LETA-CFFO.
      *
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'B'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
      * 
           MOVE 'A'        TO LETA-VALA.
           MOVE X'0D'      TO LETA-VACR.
           MOVE X'0A'      TO LETA-VALF.
           WRITE RF-LET.
       EX-REC-A.
           EXIT.
      *-----*
       CREA-REC-B.
           MOVE SPACE   TO LETB.
      *
           MOVE ZERO TO LETB-PRMO.
           MOVE ZERO TO LETB-DICO.
           MOVE ZERO TO LETB-PROT1.
           MOVE ZERO TO LETB-PROT2.
           MOVE ZERO TO LETB-PIVA.
           MOVE ZERO TO LETB-DTNA.
           MOVE ZERO TO LETB-CFISCS.
           MOVE ZERO TO LETB-CODC.
           MOVE ZERO TO LETB-DTNAF.
           MOVE ZERO TO LETB-CACQ.
           MOVE ZERO TO LETB-CIMP.
           MOVE ZERO TO LETB-ANNO.
           MOVE ZERO TO LETB-IMPO.
           MOVE ZERO TO LETB-IMPC.
      **** rel 7.2
      *    MOVE ZERO TO LETB-DTDA.
      *    MOVE ZERO TO LETB-DTA.
           MOVE SPACE TO LETB-FILDA.
           MOVE SPACE TO LETB-FILA.
      ************
      **** rel 7.3
      *    MOVE ZERO TO LETB-ANNOD.
      ************
           MOVE ZERO TO LETB-DOGA.
           MOVE ZERO TO LETB-PIVAD.
           MOVE ZERO TO LETB-TPLA.
           MOVE ZERO TO LETB-CDIAP.
           MOVE ZERO TO LETB-EPSO.
           MOVE ZERO TO LETB-CINTRA.
           MOVE ZERO TO LETB-CSANM.
           MOVE ZERO TO LETB-OPERAS.
           MOVE ZERO TO LETB-OPERST.
           MOVE ZERO TO LETB-DTIM.
      *
           MOVE 'B'       TO LETB-TRB.
           MOVE 1         TO LETB-PRMO.
           MOVE AZI-CFISC TO LETB-CFDI.
           MOVE '00343650131' TO LETB-PSWG.
      *--- Integrativa
           MOVE IF-DICO  TO LETB-DICO.
           MOVE IF-PROT1 TO LETB-PROT1.
           MOVE IF-PROT2 TO LETB-PROT2.
      *  Dati del contribuente
           IF AAZ-CGN = SPACE GO TO DENOMA.
           MOVE AAZ-CGN  TO LETB-COGN.
           MOVE AAZ-NOM  TO LETB-NOME.
           MOVE SPACE    TO LETB-DENO.
           MOVE SPACE    TO LETB-SESS.
           IF AAZ-CGN NOT = SPACE
              MOVE AAZ-SES TO LETB-SESS.
           MOVE AAZ-DNA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO LETB-DTNA.
           MOVE AAZ-CNA  TO LETB-CONA.
           MOVE AAZ-PNA  TO LETB-PRNA.
           GO TO NODENOMA.
       DENOMA.
           MOVE SPACE    TO LETB-COGN.
           MOVE SPACE    TO LETB-NOME.
           MOVE AZRGSOC  TO LETB-DENO.
           MOVE ZERO     TO LETB-DTNA.
           MOVE SPACE    TO LETB-SESS.
       NODENOMA.
           MOVE AZI-PIVA TO LETB-PIVA.
      *--- Dati relativi al rappresentante firmatario della dichiarazion
      *** Dati soggetto tenuto alla comunicazione
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'B'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
           MOVE D02-CFRAP TO LETB-CFISC.
           MOVE D02-CARAP TO LETB-CODC.
      *** Dati soggetto tenuto alla comunicazione(Persona fisica)
           MOVE D02-CORAP TO LETB-CNF.
           MOVE D02-NORAP TO LETB-NOF.
           IF D02-CORAP NOT = SPACE
              MOVE D02-SERAP TO LETB-SEF.
           MOVE D02-DTRAP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO LETB-DTNAF.
           MOVE D02-CONRAP TO LETB-COFN.
           MOVE D02-PRNRAP TO LETB-PRFN.
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'C'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
           MOVE D02-TELRAP TO LETB-NTEL.
           MOVE D02-CFSOC TO LETB-CFISCS.
      *
           IF IF-DOGA =  1
              MOVE 1     TO LETB-CIMP
              MOVE ZERO  TO LETB-CACQ
           ELSE
              MOVE 1     TO LETB-CACQ
              MOVE ZERO  TO LETB-CIMP.
           MOVE IF-ANNO  TO LETB-ANNO.
           MOVE ZERO TO COMIMPO COMIMPC.
           IF IF-TPDIC = 1
              MOVE IF-IMPOR  TO COMIMPO
              MOVE ZERO      TO COMIMPC.
           IF IF-TPDIC = 2
              MOVE ZERO     TO COMIMPO
              MOVE IF-IMPOR TO COMIMPC.
           MOVE COMIMPO TO LETB-IMPO.
           MOVE COMIMPC TO LETB-IMPC.
      **** rel 7.2
      *    IF IF-TPDIC = 3
      *       MOVE IF-PERG1 TO GG4
      *       MOVE IF-PERM1 TO MM4
      *       MOVE IF-ANNO  TO AA4
      *       MOVE GGMMAA4  TO LETB-DTDA
      *       MOVE IF-PERG2 TO GG4
      *       MOVE IF-PERM2 TO MM4
      *       MOVE IF-ANNO  TO AA4
      *       MOVE GGMMAA4  TO LETB-DTA.
      ************
           MOVE IF-DESCR-1  TO LETB-DESCR.
      **** rel 7.3
      *    MOVE SAV-PRT   TO LETB-NATTR.
           MOVE SPACE       TO LETB-NATTR.   *> filler
      ************
           ADD 1 TO SAV-PRT.
      **** rel 7.3
      *    MOVE KRGL-INUIVA TO LETB-NATTR.
      *    MOVE IF-ANNO     TO LETB-ANNOD.
           MOVE SPACE       TO LETB-ANNOD.   *> filler
      ************
      *
           IF IF-DOGA =  1
              MOVE 1     TO LETB-DOGA
           ELSE
              MOVE ZERO  TO LETB-DOGA.
           IF LETB-DOGA = 1
              GO TO NO-DICHIA.
           MOVE CLF-CFISC TO LETB-CFISCD.
           IF CLF-CFISC = SPACE OR
              CLF-13IVA = 4 
              IF (CLF-CFISC(1:11) NUMERIC AND CLF-CFISC(12:) = SPACE)
              OR (CLF-CFISC(16:1) NOT = SPACE)
              GO TO NO-MOD
           ELSE
              MOVE CLF-PIVA TO LETB-CFISCD.
       NO-MOD.
           MOVE CLF-PIVA TO LETB-PIVAD.
           MOVE CLF-XRGS TO LETB-DENOM.
       NO-DICHIA.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
           COMPUTE LETB-TPLA = D02-TPLA + 1. 
           MOVE D02-CDIAP  TO  LETB-CDIAP.
           MOVE D02-EPSO   TO  LETB-EPSO.
           MOVE D02-CINTRA TO  LETB-CINTRA.
           MOVE D02-CSANM  TO  LETB-CSANM.
           MOVE D02-OPERAS TO  LETB-OPERAS.
           MOVE D02-OPERST TO  LETB-OPERST.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'I'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
           MOVE D02-CFINT TO LETB-CFISI.
      **** rel 7.2
      *    MOVE D02-DTIMP TO AAGGG.
           MOVE COM-DTIMP TO AAGGG.
      *********
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO LETB-DTIM.
           MOVE 1    TO LETB-FIRMA.
           IF LETB-CFISI NOT = SPACE AND
              LETB-CFISI NOT = ZERO
              MOVE 1 TO LETB-FIRMAI
           ELSE
              MOVE 0 TO LETB-FIRMAI.
      *
           MOVE 'A'          TO LETB-VALA.
           MOVE X'0D'        TO LETB-VACR.
           MOVE X'0A'        TO LETB-VALF.
           ADD 1 TO NRECB.
           WRITE RF-LET.
       EX-REC-B.
      *    EXIT.
      *-----*
       CREA-REC-Z.
           MOVE SPACE TO LETZ.
      *    
           MOVE 'Z'   TO LETZ-TRZ.
      *
           MOVE NRECB   TO LETZ-NRTB.
      *
           MOVE 'A'     TO LETZ-VALA.
           MOVE X'0D'   TO LETZ-VACR.
           MOVE X'0A'   TO LETZ-VALF.
           WRITE RF-LET.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           SUBTRACT 1 FROM SAV-PRT.
           MOVE SAV-PRT TO T25-PRT.
           REWRITE RF-TAB FROM REKT25 INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
       EX-REC-Z.
           EXIT.
      *-----*
